Skip to content
Start here

Create Vectorize Index

client.Vectorize.Indexes.New(ctx, params) (*CreateIndex, error)
POST/accounts/{account_id}/vectorize/v2/indexes

Creates and returns a new Vectorize Index.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Vectorize Write
ParametersExpand Collapse
params IndexNewParams
AccountID param.Field[string]

Path param: Identifier

maxLength32
Config param.Field[IndexNewParamsConfig]

Body param: Specifies the type of configuration to use for the index.

type IndexDimensionConfiguration struct{…}
Dimensions int64

Specifies the number of dimensions for the index

maximum1536
minimum1
Metric IndexDimensionConfigurationMetric

Specifies the type of metric to use calculating distance.

One of the following:
const IndexDimensionConfigurationMetricCosine IndexDimensionConfigurationMetric = "cosine"
const IndexDimensionConfigurationMetricEuclidean IndexDimensionConfigurationMetric = "euclidean"
const IndexDimensionConfigurationMetricDOTProduct IndexDimensionConfigurationMetric = "dot-product"
type IndexNewParamsConfigVectorizeIndexPresetConfiguration struct{…}
Preset IndexNewParamsConfigVectorizeIndexPresetConfigurationPreset

Specifies the preset to use for the index.

One of the following:
const IndexNewParamsConfigVectorizeIndexPresetConfigurationPresetCfBaaiBgeSmallEnV1_5 IndexNewParamsConfigVectorizeIndexPresetConfigurationPreset = "@cf/baai/bge-small-en-v1.5"
const IndexNewParamsConfigVectorizeIndexPresetConfigurationPresetCfBaaiBgeBaseEnV1_5 IndexNewParamsConfigVectorizeIndexPresetConfigurationPreset = "@cf/baai/bge-base-en-v1.5"
const IndexNewParamsConfigVectorizeIndexPresetConfigurationPresetCfBaaiBgeLargeEnV1_5 IndexNewParamsConfigVectorizeIndexPresetConfigurationPreset = "@cf/baai/bge-large-en-v1.5"
const IndexNewParamsConfigVectorizeIndexPresetConfigurationPresetOpenAITextEmbeddingAda002 IndexNewParamsConfigVectorizeIndexPresetConfigurationPreset = "openai/text-embedding-ada-002"
const IndexNewParamsConfigVectorizeIndexPresetConfigurationPresetCohereEmbedMultilingualV2_0 IndexNewParamsConfigVectorizeIndexPresetConfigurationPreset = "cohere/embed-multilingual-v2.0"
Name param.Field[string]

Body param

Description param.Field[string]optional

Body param: Specifies the description of the index.

ReturnsExpand Collapse
type CreateIndex struct{…}
Dimensions int64

Specifies the number of dimensions for the index

maximum1536
minimum1
Metric IndexDimensionConfigurationMetric

Specifies the type of metric to use calculating distance.

One of the following:
const IndexDimensionConfigurationMetricCosine IndexDimensionConfigurationMetric = "cosine"
const IndexDimensionConfigurationMetricEuclidean IndexDimensionConfigurationMetric = "euclidean"
const IndexDimensionConfigurationMetricDOTProduct IndexDimensionConfigurationMetric = "dot-product"
CreatedOn Timeoptional

Specifies the timestamp the resource was created as an ISO8601 string.

formatdate-time
Description stringoptional

Specifies the description of the index.

ModifiedOn Timeoptional

Specifies the timestamp the resource was modified as an ISO8601 string.

formatdate-time
Name stringoptional

Create Vectorize Index

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/vectorize"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  createIndex, err := client.Vectorize.Indexes.New(context.TODO(), vectorize.IndexNewParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Config: cloudflare.F[vectorize.IndexNewParamsConfigUnion](vectorize.IndexDimensionConfigurationParam{
      Dimensions: cloudflare.F(int64(768)),
      Metric: cloudflare.F(vectorize.IndexDimensionConfigurationMetricCosine),
    }),
    Name: cloudflare.F("example-index"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", createIndex.Config)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "config": {
      "dimensions": 768,
      "metric": "cosine"
    },
    "created_on": "2022-11-15T18:25:44.442097Z",
    "description": "This is my example index.",
    "modified_on": "2022-11-15T18:25:44.442097Z",
    "name": "example-index"
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "config": {
      "dimensions": 768,
      "metric": "cosine"
    },
    "created_on": "2022-11-15T18:25:44.442097Z",
    "description": "This is my example index.",
    "modified_on": "2022-11-15T18:25:44.442097Z",
    "name": "example-index"
  },
  "success": true
}